<script lang="ts">
import Vue from 'vue';
import { CtfEntry, CtfTheSourceAuthor } from '~/models';
import { getAvailableLanguagesFromTags } from '~/common/util';
import { AvailableLanguagesMixin } from '~/mixins';
import TheSourceAuthorHero from '~/components/the-source/author-hero.vue';
import TheSourceArticlesList from '~/components/the-source/articles-list.vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { getPageMetadata } from '~/common/meta';

export default Vue.extend({
  components: { TheSourceArticlesList, TheSourceAuthorHero },
  mixins: [AvailableLanguagesMixin],
  layout: 'the-source',
  async middleware(context) {
    if (process.client) {
      return;
    }

    const slug = `the-source/authors/${context.params.slug}`;

    const page: CtfEntry<CtfTheSourceAuthor> =
      await context.$theSourceService.getAuthor(slug);

    context.$pageData = page;

    context.$availableLanguages = getAvailableLanguagesFromTags(
      page.metadata.tags,
    );
  },
  async asyncData({ $pageData, $theSourceService, $availableLanguages }) {
    const author: CtfTheSourceAuthor = $pageData.fields;
    const authorArticles = await $theSourceService.getArticlesByAuthor(
      $pageData.sys.id,
    );

    const metadata = {
      title: author.name,
      description: author.bio,
    };

    return {
      author,
      authorArticles,
      metadata,
      availableLanguages: $availableLanguages,
    };
  },
  head(): MetaInfo {
    return getPageMetadata(
      this.metadata,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
      this.availableLanguages,
    );
  },
});
</script>

<template>
  <div>
    <TheSourceAuthorHero :author="author" />
    <SlpContainer>
      <TheSourceArticlesList :articles="authorArticles" disable-author />
    </SlpContainer>
  </div>
</template>

<style scoped lang="scss"></style>
